﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace JiPP_2016_04_24
{
  public partial class Form1 : Form
  {
    public Form1()
    {
      InitializeComponent();
    }


    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    //        MODYFIAKTORY
    //       (dyrektywy określające poziom dostępu do składników klasy)
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    internal class DemoModyfikatorow
    {

      // Składnik publiczny - dostępny bez żadnych ograniczeń
      public int A1;



      // Składnik prywatny - dostępny wyłącznie wewnątrz posiadającej go klasy 
      private int a2;


      // Składnik chroniony - wyłącznie wewnątrz posiadającej go klasy i klas potomnych
      protected int A3;


      public void M1()
      {
        a2 = 234;
        A3 = 555;

        MessageBox.Show(
          A1.ToString()
          + " !!!! "
          + a2.ToString()
          + "  "
          + A3.ToString()
        );
      }
    }


    private void btnModyfikatory_Click(object sender, EventArgs e)
    {
      DemoModyfikatorow o = new DemoModyfikatorow();
      o.A1 = 123;
      //o.a2 = 444; składnik niedostępny bo jest private
      //o.A3 = 888; składnik niedostępny bo jest protected czyli dostępny wewnątrz własnej klasy oraz w klasach potomnych
      o.M1();
    }


    private void btnModyfikatory2_Click(object sender, EventArgs e)
    {
      //Demo modyfikatora internal
      NieInternal.DemoModyfikatorow2 o2 = new NieInternal.DemoModyfikatorow2();
      o2.PolePubliczne = 1;
      //o2.PoleWewnetrzne = 2; składnik niedostępny bo jest internal - czyli dostępny tylko w assembly/projekcie "NieInternal"
    }


    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    //        METODY PRZEŁADOWANE
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!



    class MetodyOverloaded
    {
      public void M2(string p1)
      {
        MessageBox.Show(p1);
      }
      public void M2(string p1, int p2)
      {
        MessageBox.Show(p1 + "  " + p2.ToString());
      }

      public void M2()
      {
        MessageBox.Show("!");
      }
    }



    private void btnOverloaded_Click(object sender, EventArgs e)
    {
      MetodyOverloaded mo = new MetodyOverloaded();
      mo.M2();
      mo.M2("Ala ma kota");
      mo.M2("A kot ma Alę", 123);
    }



    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    //        KONSTRUKTORY
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!


    class KlasaZKonstruktorem
    {
      private string A7;

      //Konstruktor z jednym parametrem typu string przekazywanym przez wartość
      //służącym do inicjacji wartości pola prywatnego A7.
      public KlasaZKonstruktorem(string jakisString)
      {
        A7 = jakisString;
      }
      public void PokazPole()
      {
        MessageBox.Show(A7.ToString());
      }

    }

    private void btnConstructors_Click(object sender, EventArgs e)
    {
      KlasaZKonstruktorem kzk = new KlasaZKonstruktorem("AAAA!");
      kzk.PokazPole();
    }



    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    //        WŁAŚCIWOŚCI
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    class KlasaZWlasciwosciami : INotifyPropertyChanged
    {

      //Właściwość W1 jest funkcjonalnie równoważna zapisowi zastosowanemu do definicji właściwości W3
      public string W1 { get; set; }




      public string W3
      {
        get { return w3; }
        set { w3 = value; }
      }
      private string w3;



      //Właściwość W2 "powiadamia" o zmianie przechowywanej wartości co pozwala na 
      //automatyczną aktualizację powiązanych z nią kontrolek
      public string W2
      {
        get { return w2; }
        set
        {
          w2 = value;
          if (PropertyChanged != null)
          {
            PropertyChanged(this, new PropertyChangedEventArgs("W2"));
          }
        }
      }
      private string w2;


      //to jedyny składnik jaki jest wymagany do implementacji interfejsu INotifyPropertyChanged
      public event PropertyChangedEventHandler PropertyChanged;
    }

    KlasaZWlasciwosciami kzw = new KlasaZWlasciwosciami();


    private void button4_Click(object sender, EventArgs e)
    {
      kzw.W2 = textBox1.Text;
    }

    private void button6_Click(object sender, EventArgs e)
    {
      MessageBox.Show(kzw.W2);
    }

    private void button5_Click(object sender, EventArgs e)
    {
      kzw.W2 = "Ala ma kota";
      Binding ba = new Binding("Text", kzw, "W2", false, DataSourceUpdateMode.OnPropertyChanged);
      textBox2.DataBindings.Add(ba);

    }



    private void button7_Click(object sender, EventArgs e)
    {
      kzw.W2 = "... a kot ma Alę";
    }




    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
    //        DZIEDZICZENIE
    //!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

    class Bazowa
    {
      public string P1;
      public int I1 { get; set; }
      public void M1()
      {
        MessageBox.Show("Metoda z klasy Bazowa " + P1 + "   " + I1.ToString());
      }

      public virtual void MVirt()
      {
        MessageBox.Show("Metoda z klasy Bazowa");
      }
    }


    class Potomna1 : Bazowa
    {
      new public void M1()
      {
        MessageBox.Show("Metoda z klasy Potomna1");
      }

      public void M2()
      {
        MessageBox.Show("Metoda z klasy Potomna1   " + P1 + "   " + I1.ToString());
      }

      public override void MVirt()
      {
        MessageBox.Show("Metoda z klasy Potomna1");
      }
    }


    class Potomna2 : Bazowa
    {
      public void M2222()
      {
        MessageBox.Show("Metoda z klasy Potomna2   " + P1 + "   " + I1.ToString());
      }
    }



    private void button8_Click(object sender, EventArgs e)
    {
      Potomna1 pt1 = new Potomna1();
      pt1.I1 = 234;
      pt1.P1 = "YYYYYYYYYYYYYY";
      pt1.M1();
    }

    private void button9_Click(object sender, EventArgs e)
    {
      //Deklaracje i konstruowanie obiektów zgodne typami
      //Bazowa b = new Bazowa();
      //Potomna1 p1 = new Potomna1();
      //Potomna2 p2 = new Potomna2();

      Bazowa b = new Potomna1();
      (b as Potomna1).M2();
      //Potomna1 p = new Bazowa(); - brak zgodności

    }



    //Metody zwykłe///////////////////////////////////////////////////////

    private void btnMetZwkl_1_Click(object sender, EventArgs e)
    {
      Bazowa b = new Bazowa();
      b.M1();
    }

    private void btnMetZwkl_2_Click(object sender, EventArgs e)
    {
      Potomna1 p;
      p = new Potomna1();
      p.M1();
    }

    private void btnMetZwkl_3_Click(object sender, EventArgs e)
    {
      Bazowa b = new Potomna1();
      b.M1();//metoda zwykła -> o wariancie metody M1 decyduje typ zmiennej
    }


    //Metody wirtualne /////////////////////////////////////////////////////
    private void btnMetVirt_1_Click(object sender, EventArgs e)
    {
      Bazowa b = new Bazowa();
      b.MVirt();           
    }

    private void btnMetVirt_2_Click(object sender, EventArgs e)
    {      
      Potomna1 p =new Potomna1();
      p.MVirt();
    }

    private void btnMetVirt_3_Click(object sender, EventArgs e)
    {
      Bazowa b = new Potomna1();
      b.MVirt();//metoda wirtualna -> o wariancie metody M1 decyduje typ obiektu
    }










  }
}
